#include "extrand_int.h"

unsigned long __random_028(unsigned long n) /*this routine gratuitously stolen from the
Java standard library, with a few modifications to fit on a 32 bit machine and work with
unsigned numbers*/
{
	unsigned short workNum;
	unsigned long bits = 0;
	unsigned long value;

	if(n <= 1) /*trivial case*/
	{
		return(0);
	}

	if((n & -n) == n) /*if n is a power of 2*/
	{
		//Thanks for this "log base 2" routine go to Thomas Nussbaumer, Scott Noveck, and
		//Ryan Cumings
		if(n & 0xFFFF0000)
		{
			bits = 16;
			workNum = n >> 16;
		} // It's now guaranteed to be in the bottom 2 bytes
		else
		{
			workNum = n;
		}

		if(workNum & 0xFF00)
		{
			bits += 8;
		}

		if(workNum & 0xF0F0)
		{
			bits += 4;
		}

		if(workNum & 0xCCCC)
		{
			bits += 2;
		}

		if(workNum & 0xAAAA)
		{
			bits++;
		}

		return(__rand_028() >> (32 - bits)); /*return the appropriate number of high bits
		of the 32-bit random number*/
	}

	do
	{
		bits = __rand_028();
		value = bits % n;
	} while(bits + n <= value);

	return(value);
}
